/*********************************************************************
 * FAT File System Header File
 *
 * Filesystem based on USBwiz OEM board
 *
 * Author: Craig A. Lindley
 * Last Update: 11/18/2007
 ********************************************************************/

#ifndef __FFS_H
#define __FFS_H

#include "GenericTypeDefs.h"

// Error codes
#define FFS_NO_ERROR          0
#define FFS_EOF              -1
#define FFS_NO_HANDLE		 -2
#define FFS_FNF_ERROR        -3
#define FFS_DNF_ERROR        -4
#define FFS_HWD_INIT_ERROR   -5
#define FFS_VERSION_ERROR    -6
#define FFS_OPEN_ERROR       -7
#define FFS_SEEK_ERROR       -8
#define FFS_READ_ERROR       -9

// Device equates
#define SD_DEVICE		    'S'
#define USB_DEVICE_PORT_0   '0'
#define USB_DEVICE_PORT_1   '1'

// Public function prototypes
BYTE FFS_Init(BYTE device);
BOOL FFS_FileExists(char *filename, DWORD *size);
BYTE FFS_GetFileHandle(char *filename, BYTE *handleptr);
BYTE FFS_ReadFile(BYTE *handleptr, BYTE *buffer, DWORD *offset, DWORD reqsize, DWORD *readsize);
BYTE FFS_CleanUp(BYTE *handleptr);

#endif

