// Modified version of USBwiz library header file
// Modified by Craig Lindley
// Last Update: 11/23/2007
 
#ifndef _GHI_USBWIZ_HEADER
#define _GHI_USBWIZ_HEADER

#include "TCPIP Stack/ErrorCode.h"
#include "TCPIP Stack/GHI_inter_user.h"

#define GHI_USBWIZ_LIBRARY_VERSION 0x100

#define SD_DEVICE							'S'
#define USB_DEVICE_PORT_0					'0'
#define USB_DEVICE_PORT_1					'1'

#define FILE_READ_MODE						'R'

// Expose only the public callable functions needed
// for the webserver
int16 GHI_GetLibraryVersion(void);
int8 GHI_MountFATFileSystem(int8 device);
int8 GHI_ChangeDirectory(int8* filename);
int8 GHI_OpenFile(int8 filehandle, int8 *filename, int8 openmode);
int8 GHI_CloseFile(int8 filehande);
int8 GHI_SeekFile(int8 filehandle, int32 newposition);
int8 GHI_GetFileInfo(int8 *filename, int32 *size, int8 *attributes, int32 *TimeDate);
int8 GHI_ReadFile(int8 handle, int8 *buffer, int32 size, int8 filler, int32 *actualdatasize);

#endif
